#version 330 core

uniform mat4 mvpMatrix;
uniform mat4 mvMatrix;
uniform mat4 vMatrix;
uniform mat3 nMatrix;
uniform vec3 lightPosition_world; // light in world space

layout(location=0) in vec3 position;
layout(location=1) in vec2 in_UV;
layout(location=2) in vec3 normal;

out vec2 uv;

out vec3 normal_eye;
out vec3 viewDirection_eye;
out vec3 lightDirection_eye;

void main(void)
{
	gl_Position = mvpMatrix * vec4(position, 1.0);
	uv = in_UV;

	vec3 normal = nMatrix * normal;
	normal_eye = normalize(normal);
	vec3 position_eye =  (mvMatrix * vec4(position, 1.0)).xyz;
	viewDirection_eye = vec3(0.0, 0.0, 0.0) -position_eye;
	vec3 lightPosition_eye = (vMatrix * vec4(lightPosition_world, 1.0)).xyz;
	lightDirection_eye = lightPosition_eye - position_eye;
}

