#version 330 core

uniform sampler2D textureMap;
uniform vec4 objectColor;
uniform vec4 uvArea;
uniform vec4 colorRangeStart;
uniform vec4 colorRangeEnd;
uniform float transparency;

in vec2 uv;

out vec4 color;

void main(void)
{
	color = texture2D(textureMap, uv);

	if (all(greaterThanEqual(uv.xy, uvArea.xy)) && all(lessThanEqual(uv.xy, uvArea.zw))) {
		if (all(greaterThanEqual(color, colorRangeStart)) && all(lessThanEqual(color, colorRangeEnd))) {
			color += objectColor;
			clamp(color, 0, 1);
		}
	}
}
